#ifndef WTRUNTIME_OPERATOR_H
#define WTRUNTIME_OPERATOR_H

#include "config.h"
#include "types.h"
#include "wtruntime.h"

struct wtr_program;
struct wtr_type;

struct wtr_operator
{
	struct wtr_node     link_ops;      /* link in wtr_vm::list_operators */
	wt_u32              precedence;    /* WTBSYM_OP_MINPREC .. WTBSYM_OP_MAXPREC */
	wt_u32              associativity; /* WTBSYM_OP_*ASSOC */
	wt_uintptr          refcount;      /* reference counter */
	const char*         name;          /* operator symbol */
	struct wtr_program* program;       /* owner program */
};

struct wtr_operator* wtr_operator_new(struct wtr_program* program, const char* name, wt_u32 prec, wt_u32 assoc);
void wtr_operator_release(struct wtr_operator* op);
int wtr_operator_cmp(const struct wtr_operator* lhs, const struct wtr_operator* rhs);

#endif /* WTRUNTIME_OPERATOR_H */
